#include <stdio.h>

#include <Box.h>
#include <ColorControl.h>
#include <GraphicsDefs.h>

#include "ColorBox.h"

ColorBox::ColorBox(BRect aRect, rgb_color aColor) 
: BBox(aRect, NULL, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW | B_FRAME_EVENTS, B_NO_BORDER)
{
	color_view = new BView(Bounds().InsetByCopy(2,2), "color_view", B_FOLLOW_LEFT, B_WILL_DRAW);
	color_view->SetViewColor(aColor);
	AddChild(color_view);
}

ColorBox::~ColorBox()
{

}

void 
ColorBox::MouseDown(BPoint point)
{
	// Just create the ColorControl Window,
	// and get it out there.
	// 
	// We can worry about clicks & drags later.

}

void
ColorBox::AttachedToWindow()
{
	//	BBox::AttachedToWindow();
	//	Prevents Box from catching color from parent?
}

void	
ColorBox::SetColor(rgb_color aColor)
{
	color_view->SetViewColor(aColor);
}

rgb_color
ColorBox::GetColor()
{
	return color_view->ViewColor();
}
