#include <stdio.h>
#include <stdlib.h>

#include <be/kernel/fs_index.h>

#include <be/app/Roster.h>
#include <be/app/Application.h>
#include <be/app/Message.h>

#include <Alert.h>
#include <Window.h>
#include <TextControl.h>
#include <CheckBox.h>
#include <Button.h>
#include <GraphicsDefs.h>

#include <storage/FindDirectory.h>
#include <storage/Directory.h>
#include <storage/Path.h>
#include <storage/File.h>
#include <storage/VolumeRoster.h>
#include <storage/Volume.h>

#include <String.h>
#include <Beep.h>

#include "setWin.h"
#include "ColorBox.h"
#include "Colors.h"

setWin::setWin()
: BWindow(BRect(200,100,395,375), "Labels", B_TITLED_WINDOW, B_NOT_RESIZABLE | B_NOT_ZOOMABLE)
{
//	init	
	DoModify	=	true;
	DoTint		=	true;
	
//	making the UI
	BView * view	=	new BView(BRect(0,0,200,300), "main", B_FOLLOW_ALL_SIDES, B_NAVIGABLE);

	rgb_color color = {216, 216, 216, 0};	
	view		->	SetViewColor(color);

	view	->AddChild(	box1	=	new ColorBox	(BRect(5,5,25,25),	Orange));
	view	->AddChild(	box2	=	new ColorBox	(BRect(5,30,25,50),	Red));
	view	->AddChild(	box3	=	new ColorBox	(BRect(5,55,25,75), Lavender));
	view	->AddChild(	box4	=	new ColorBox	(BRect(5,80,25,100), LightBlue));
	view	->AddChild(	box5	=	new ColorBox	(BRect(5,105,25,125), Blue));
	view	->AddChild(	box6	=	new ColorBox	(BRect(5,130,25,150), Green));
	view	->AddChild(	box7	=	new ColorBox	(BRect(5,155,25,175), Black));
//	view	->AddChild(	box8	=	new ColorBox	(BRect(5,180,25,200), Black));
	
	
	view	->AddChild(	label1	=	new BTextControl (BRect(26,5,190,25), NULL, NULL, "Essential", NULL));
	view	->AddChild(	label2	=	new BTextControl (BRect(26,30,190,50), NULL, NULL, "Hot", NULL));
	view	->AddChild(	label3	=	new BTextControl (BRect(26,55,190,75), NULL, NULL, "In Progress", NULL));
	view	->AddChild(	label4	=	new BTextControl (BRect(26,80,190,100), NULL, NULL, "Cool", NULL));
	view	->AddChild(	label5	=	new BTextControl (BRect(26,105,190,125), NULL, NULL, "Personal", NULL));
	view	->AddChild(	label6	=	new BTextControl (BRect(26,130,190,150), NULL, NULL, "Project 1", NULL));
	view	->AddChild(	label7	=	new BTextControl (BRect(26,155,190,175), NULL, NULL, "Project 2", NULL));
//	view	->AddChild(	label8	=	new BTextControl (BRect(26,180,190,200), NULL, NULL, NULL, NULL));
	
	view	->AddChild(TintBox		=	new	BCheckBox(BRect(5,180,110,200), "Tint", "Tint Icons", new BMessage('tint')));
	view	->AddChild(ModifyBox	=	new	BCheckBox(BRect(5,200,110,220), "Modify", "Set Modified", new BMessage('modi')));
	//view	->AddChild(IndexBox		=	new	BCheckBox(BRect(5,220,110,240), "Index", "Index Label Attribute", new BMessage('indx')));
	//view	->AddChild(TrackerBox	=	new	BCheckBox(BRect(5,240,110,260), "Tracker", "Show Labels in Tracker", new BMessage('trak')));
	
	view	->AddChild(new	BButton(BRect(125,185,180,205), "About", "About", new BMessage('abou')));
	
	view	->AddChild(new	BButton(BRect(5,220,190,240), "Tracker", "Show Labels in Tracker" B_UTF8_ELLIPSIS, new BMessage('trak')));
	view	->AddChild(new	BButton(BRect(5,246,190,266), "Index", "Turn on label indexing" B_UTF8_ELLIPSIS, new BMessage('indx')));
	
	//view	->AddChild(new	BButton(BRect(5,265,60,290), "About", "About", new BMessage('abou')));
		
	AddChild(view);
	
//	get settings
	BMessage	settings;
	BPath		path;
	status_t	status;
	if (find_directory(B_USER_SETTINGS_DIRECTORY, &path) == B_OK)
	{
		path.SetTo(path.Path(),"Mirilla");
		path.SetTo(path.Path(),"Label");
		BFile file;
		if ((status = file.SetTo(path.Path(),B_READ_ONLY)) == B_OK)
		{	settings.Unflatten(&file);	}
		else error_check("file.SetTo() ", status);
	}

	BPoint loc;
	if (settings.FindPoint("winloc",&loc) == B_OK)	MoveTo(loc);
	
	bool a;
	if (settings.FindBool("DoModify", &a) == B_OK)	DoModify = a;
	if (settings.FindBool("DoTint", &a) == B_OK)	DoTint = a;
	
	TintBox		->SetValue(DoTint);
	ModifyBox	->SetValue(DoModify);
	
	rgb_color * color2	=	new rgb_color;
	ssize_t	size = 4;
	if (settings.FindData("box1", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box1->SetColor (*color2);
	if (settings.FindData("box2", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box2->SetColor (*color2);
	if (settings.FindData("box3", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box3->SetColor (*color2);
	if (settings.FindData("box4", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box4->SetColor (*color2);
	if (settings.FindData("box5", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box5->SetColor (*color2);
	if (settings.FindData("box6", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box6->SetColor (*color2);
	if (settings.FindData("box7", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box7->SetColor (*color2);
//	if (settings.FindData("box8", B_ANY_TYPE, (const void**) &color2, &size) == B_OK)		box8->SetColor (*color2);
	
	if (settings.HasString("label1"))	label1->SetText(settings.FindString("label1", (int32) 0));
	if (settings.HasString("label2"))	label2->SetText(settings.FindString("label2", (int32) 0));
	if (settings.HasString("label3"))	label3->SetText(settings.FindString("label3", (int32) 0));
	if (settings.HasString("label4"))	label4->SetText(settings.FindString("label4", (int32) 0));
	if (settings.HasString("label5"))	label5->SetText(settings.FindString("label5", (int32) 0));
	if (settings.HasString("label6"))	label6->SetText(settings.FindString("label6", (int32) 0));
	if (settings.HasString("label7"))	label7->SetText(settings.FindString("label7", (int32) 0));
//	if (settings.HasString("label8"))	label8->SetText(settings.FindString("label8", (int32) 0));
}

setWin::~setWin()
{

}

void 
setWin::MessageReceived(BMessage * message)
{
	switch(message->what)
	{
		case 'modi':
					if(DoModify == true)	DoModify = false;
					else					DoModify = true;
					Save();
				break;
		case 'tint':
					if(DoTint == true)		DoTint = false;
					else					DoTint = true;
					Save();
				break;
		case 'indx':
					CreateIndex();
					break;
		case 'trak':
					ShowInTracker();
					break;
		case 'abou':
					about();
					break;
		case 'quit':
					Quit();
					break;
					
		default:
			BWindow::MessageReceived(message);
	}
}

void
setWin::error_check(const char * message, int32 status)
{
	printf(message);

	if (status == B_OK)					printf("B_OK \n");
	if (status == B_ERROR)				printf("B_ERROR \n");
	if (status == B_ENTRY_NOT_FOUND)	printf("B_ENTRY_NOT_FOUND \n");
	if (status == B_FILE_ERROR)			printf("B_FILE_ERROR \n");
	if (status == B_NOT_ALLOWED)		printf("B_NOT_ALLOWED \n");
	if (status == B_DEVICE_FULL)		printf("B_DEVICE_FULL \n");
	if (status == B_NO_MEMORY)			printf("B_NO_MEMORY \n");
	if (status == B_BAD_VALUE)			printf("B_BAD_VALUE \n");
	if (status == B_BUSY)				printf("B_BUSY \n");
	if (status == B_NO_INIT)			printf("B_NO_INIT \n");
	if (status == B_PERMISSION_DENIED)	printf("B_PERMISSION_DENIED \n");
	if (status == B_FILE_EXISTS)		printf("B_FILE_EXISTS \n");
}

void
setWin::Quit()
{
	Save();
	be_app->PostMessage(B_QUIT_REQUESTED);
	BWindow::Quit();
}

void
setWin::Save()
{
//	making the settings message
	BMessage settings;
	settings.AddPoint("winloc",Frame().LeftTop());
	settings.AddBool	("DoTint", DoTint);
	settings.AddBool	("DoModify", DoModify);
		
	rgb_color temp;
	temp = box1->GetColor();		settings.AddData ("box1", B_ANY_TYPE, &temp, 4);
	temp = box2->GetColor();		settings.AddData ("box2", B_ANY_TYPE, &temp, 4);
	temp = box3->GetColor();		settings.AddData ("box3", B_ANY_TYPE, &temp, 4);
	temp = box4->GetColor();		settings.AddData ("box4", B_ANY_TYPE, &temp, 4);
	temp = box5->GetColor();		settings.AddData ("box5", B_ANY_TYPE, &temp, 4);
	temp = box6->GetColor();		settings.AddData ("box6", B_ANY_TYPE, &temp, 4);
	temp = box7->GetColor();		settings.AddData ("box7", B_ANY_TYPE, &temp, 4);
//	temp = box8->GetColor();		settings.AddData ("box8", B_ANY_TYPE, &temp, 4);
	
	settings.AddString("label1", label1->Text());
	settings.AddString("label2", label2->Text());
	settings.AddString("label3", label3->Text());
	settings.AddString("label4", label4->Text());
	settings.AddString("label5", label5->Text());
	settings.AddString("label6", label6->Text());
	settings.AddString("label7", label7->Text());
//	settings.AddString("label8", label8->Text());

//	storing it
	BPath path;
	if (find_directory(B_USER_SETTINGS_DIRECTORY, &path) == B_OK)
	{
		BDirectory	set_dir(path.Path());
		BDirectory	m_dir;
		set_dir.CreateDirectory("Mirilla", &m_dir);
			
		path.SetTo(path.Path(),"Mirilla");
		path.SetTo(path.Path(),"Label");

		BFile file;
		if (file.SetTo(path.Path(), B_WRITE_ONLY | B_ERASE_FILE | B_CREATE_FILE) == B_OK)
			settings.Flatten(&file);
	}
}

void 
setWin::about()
{
	BAlert * alert = new BAlert("Label", "This is Label\n\n"
			"Don't use the source. It stinks!\n\n"
			"jonas@kirilla.com\n"
			"www.kirilla.com\n",
			"Yay, homepage!", "Thank you, and good night!", NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT);
          
	int32 reply = alert->Go();
	
	if (reply == 0)
	{
		BMessage msg(B_ARGV_RECEIVED); 
		msg.AddString("argv", "NetPositive"); 
		msg.AddString("argv", "http://www.kirilla.com");  
		msg.AddInt32("argc", 2);
		be_roster->Launch ("application/x-vnd.Be-NPOS", &msg ); 		
	}	
}

void 
setWin::CreateIndex()
{
	BVolumeRoster vol_roster;
	BVolume boot_vol;

	if (vol_roster.GetBootVolume(& boot_vol) == B_OK)
	{
		fs_create_index(boot_vol.Device(), "META:label", B_STRING_TYPE, 0);
	}

	BAlert * alert = new BAlert("Label", "It's done. Try a query now.",
			"If you say so" B_UTF8_ELLIPSIS, NULL, NULL, B_WIDTH_AS_USUAL, B_INFO_ALERT);

	alert->Go(NULL);

}

void 
setWin::ShowInTracker()
{
	// TODO
	
	BAlert * alert = new BAlert("Label", "Not implemented yet.",
			"Dissappointed!", NULL, NULL, B_WIDTH_AS_USUAL, B_STOP_ALERT);

	alert->Go(NULL);
}
