#include "BarberPole.h"
#include "Colors.h"

BarberPole::BarberPole(BRect pRect, const char *pName, uint32 resizingMode, uint32 flags, int pDirection)
		: BView(pRect, pName, resizingMode, flags) 
{
	is_running = false;
	direction = pDirection;
	
	lStripes.data[0] = 0x0f;
	lStripes.data[1] = 0x1e;
	lStripes.data[2] = 0x3c;
	lStripes.data[3] = 0x78;
	lStripes.data[4] = 0xf0;
	lStripes.data[5] = 0xe1;
	lStripes.data[6] = 0xc3;
	lStripes.data[7] = 0x87;
	
	box = new BBox(pRect);
	AddChild(box);
};

BarberPole::~BarberPole()
{
	
}

void 
BarberPole::Start()
{
	SetFlags(B_WILL_DRAW | B_PULSE_NEEDED);
	is_running = true;
}

void 
BarberPole::Stop()
{
	SetFlags(B_WILL_DRAW);
	is_running = false;
}

bool 
BarberPole::IsRunning()	{	return is_running;	}

void 
BarberPole::Pulse()
{
	if(LockLooper())
	{
		FillRect(Bounds());
		FillRect(Bounds().InsetByCopy(1,1), lStripes);
		UnlockLooper();
	}
	
	if(direction == FROM_RIGHT_TO_LEFT)
	{
		uchar tmp = lStripes.data[0];
		for (int j = 0; j < 7; ++j) 
			lStripes.data[j] = lStripes.data[j+1];
			
		lStripes.data[7] = tmp;
	}
	else 
	{
		uchar tmp = lStripes.data[7];
		for (int j = 7; j > 0; --j) 
			lStripes.data[j] = lStripes.data[j-1];
			
		lStripes.data[0] = tmp;
	
	}
}

