#ifndef __VOL_IDX_WINDOW_H__
#define __VOL_IDX_WINDOW_H__

#include <List.h>
#include <Window.h>
#include <CheckBox.h>
#include <Button.h>
#include <MenuField.h>
#include <Menu.h>
#include <MenuItem.h>

class VolumeIndexWindow : public BWindow
{
public:
					VolumeIndexWindow		();
					~VolumeIndexWindow		();
	virtual void	MessageReceived 		(BMessage * message);
	virtual void	Quit					();
	virtual void	FrameResized			(float width, float height);
	virtual void	Zoom					(BPoint origin, float width, float height);
			void	Update					();
			void	Help					();
			void	Save					();
			void	NewVolume				(char * vol_name);
			void 	DeleteVolume			(int32);
			void	error_check				(const char * message, int32 status);
	
			void	VolumeMounted			(fs_info *	my_fs_info);
			void	VolumeUnmounted			(dev_t	device);
			void	InitLinks				();
			bool	HasIndexInstalled		(dev_t	device);
		status_t	InstallIndex			(dev_t	device);
		status_t	RemoveIndex				(dev_t	device);
			void	UpdateIndices			(bool alert);
			
			void	EntryCreated			(dev_t	device);
			void	EntryRemoved			(dev_t	device);
			
			void	Reindex					(BMessage * msg);
			void 	Finish					(BMessage * msg);
			void	Show			 		(BMessage * msg);
					
private:
	int32	item_left, item_top, item_right, item_bottom;
	
	BView		*	label_view;
	BView		*	item_view;
	BView		*	button_view;
	BScrollView	*	my_scrollview;
	BScrollBar	*	my_bar;

	BButton		*	help_button;
	BButton		*	reindex_button;

	BVolumeRoster	*	vol_roster;
	BList			*	vol_info_list;		// list of fs_info 
	BList			*	vol_check_list;		// list of BCheckBox
	BList			*	vol_query_list;		// list of BQuery
	BList			*	vol_msgr_list;		// list of BMessenger
	BList			*	vol_string_list;	// list of BStringView
	BList			*	vol_count_list;		// list of int64
	BList			*	vol_looper_list;	// list of VolumeIndexLooper
	BList			*	vol_barber_list;	// list of BarberPole
	BList			*	vol_reindex_list;	// list of BButton
	BList			*	vol_show_list;	// list of BButton
};
#endif

